unit KOLMHFindReplaceDialog;
//  MHFindReplaceDialog  (MHFindReplaceDialog Component)
//   (Author):   (Zharov Dmitry) aka  (Gandalf)
//    (Create date): 1-(dec)-2001
//    (Last correction Date): 10-(may)-2004
//   (Version): 0.92
//  EMail: Gandalf@kol.mastak.ru
//   (Thanks):
//    (New in):
//  V0.92
//  [+]   ,    [KOLnMCK]
//  [N]    FindReplaceWndProc,  WM_CLOSE,  
//       ?
//
//  V0.81
//  [+]  D7 (D7 Support) [KOLnMCK]
//
//  V0.8
//  [N]   (Test version) [KOLnMCK]
//
//    (To-Do list):
//  1.  (Asm)
//  2.  (Optimize)
//  3.  (Clear Stuff)
//  4.  OnHelp (Events OnHelp)
//  5.  API (All API's)
//  6.   WM_CLOSE (Good WM_CLOSE)
//  7. / (Modal/No-Modal)


interface

uses
  KOL, Windows, ShellAPI, CommDlg, Messages;

type

  {
  //  FR_ENABLEHOOK = $00000100;
  //  FR_ENABLETEMPLATE = $00000200;
  //  FR_ENABLETEMPLATEHANDLE = $00002000;
    }

  TFindReplaceDialogType = (dtFind, dtReplace);

  TFindReplaceDialogOption = (doDown, doWholeWord, doMatchCase, doFindNext,
    doReplace, doReplaceAll,doShowHelp, doNoUpDown, doNoMatchCase,
    doNoWholeWord, doHideUpDown, doHideMatchCase, doHideWholeWord);

  TFindReplaceDialogOptions = set of TFindReplaceDialogOption;

  PMHFindReplaceDialog = ^TMHFindReplaceDialog;
  TKOLMHFindReplaceDialog = PMHFindReplaceDialog;

  TMHFindReplaceDialog = object(TObj)
  private
    FOwner: PControl;
    FFindText: array[0..255] of Char;
    FReplaceText: array[0..255] of Char;
    FOnFind: TOnEvent;
    FOnReplace: TOnEvent;
    FHandle: THandle;
    procedure MessageLoop;
    function GetFindText: string;
    function GetReplaceText: string;
    procedure SetFindText(const Value: string);
    procedure SetReplaceText(const Value: string);
  public
    DialogType: TFindReplaceDialogType;
    Options: TFindReplaceDialogOptions;
    function Execute: Boolean;
    property Owner: PControl read FOwner;
    property FindText: string read GetFindText write SetFindText;
    property ReplaceText: string read GetReplaceText write SetReplaceText;
    property OnFind: TOnEvent read FOnFind write FOnFind;
    property OnReplace: TOnEvent read FOnReplace write FOnReplace;
  end;

function NewMHFindReplaceDialog(AOwner: PControl): PMHFindReplaceDialog;

var
  FindMsg, HelpMsg: UINT;
  DialogsList: PList;

const
  FindReplaceDialogOption2Style: array[TFindReplaceDialogOption] of integer = (FR_DOWN
    , FR_WHOLEWORD, FR_MATCHCASE, FR_FINDNEXT, FR_REPLACE, FR_REPLACEALL
    , FR_SHOWHELP, FR_NOUPDOWN, FR_NOMATCHCASE, FR_NOWHOLEWORD
    , FR_HIDEUPDOWN, FR_HIDEMATCHCASE, FR_HIDEWHOLEWORD);

implementation

function Flags2Options(Flags: Integer): TFindReplaceDialogOptions;
  var
    i:TFindReplaceDialogOption;
  begin
    Result := [];
    for i:=Low(TFindReplaceDialogOption) to High(TFindReplaceDialogOption) do
      if (Flags and
FindReplaceDialogOption2Style[i])=FindReplaceDialogOption2Style[i] then
        Result:=Result+[i];
  end;

function FindReplaceWndProc(Sender: PControl; var Msg: TMsg; var Rslt: Integer): Boolean;
var
  FindReplace: PFindReplace;
  Self_: PMHFindReplaceDialog;
  i: Integer;
begin
  Result := False;
  if Msg.message = FindMsg then
  begin
    FindReplace := Pointer(Msg.lParam);
    Self_ := PMHFindReplaceDialog(FindReplace.lCustData);
    if (FR_DIALOGTERM and FindReplace.Flags) = FR_DIALOGTERM then
    begin
      // Cancel button pressed
      Self_.FHandle := 0;
    end;
    if (FR_FINDNEXT and FindReplace.Flags) = FR_FINDNEXT then
    begin
       if (FR_DOWN and FindReplace.Flags)=FR_DOWN then Self_.Options:=Self_.Options+[doDown] else Self_.Options:=Self_.Options-[doDown];
       if (FR_MATCHCASE and FindReplace.Flags)=FR_MATCHCASE then Self_.Options:=Self_.Options+[doMatchCase] else Self_.Options:=Self_.Options-[doMatchCase];
       if (FR_WHOLEWORD  and FindReplace.Flags)=FR_WHOLEWORD  then Self_.Options:=Self_.Options-[doNoWholeWord] else Self_.Options:=Self_.Options+[doNoWholeWord];
      // Find next button pressed
      if Assigned(Self_.FOnFind) then
        Self_.FOnFind(Self_);
    end;

    if (FindReplace.Flags and (FR_REPLACE or FR_REPLACEALL)) <> 0 then
    begin
      // Replace or replace all buttons pressed
      if Assigned(Self_.FOnReplace) then
        Self_.FOnReplace(Self_);
    end;
  end;

  if Msg.message = HelpMsg then
  begin // Help  button pressed
    //   if Assigned( FRDlgNow.FOnHelp ) then
    //   FRDlgNow.FOnHelp(FRDlgNow);
  end;

  if Msg.message = WM_CLOSE then
  begin

    if DialogsList <> nil then
    begin
      for i := 0 to DialogsList.Count - 1 do
      begin
        Self_ := PMHFindReplaceDialog(DialogsList.Items[i]);
        if Self_.Owner = Sender then
        begin
          SendMessage(Self_.FHandle, WM_CLOSE, 0, 0);
          ;
          Self_.FHandle := 0;
        end;
      end;
    end;
  end;
end;

function NewMHFindReplaceDialog(AOwner: PControl): PMHFindReplaceDialog;
begin
  New(Result, Create);
  Result.FOwner := AOwner;
  Result.FOwner.AttachProc(FindReplaceWndProc);
end;

function TMHFindReplaceDialog.Execute: Boolean;
var
  TMP: TFindReplace;
  Idx: Integer;
begin
  if DialogsList = nil then
    DialogsList := NewList;
  DialogsList.Add(@Self);
  Owner.AttachProc(FindReplaceWndProc);
  Result := False;
  Fillchar(TMP, sizeof(TMP), 0);
  with TMP do
  begin
    lStructSize := SizeOf(TMP);
    if Owner <> nil then
      hWndOwner := Owner.Handle
    else
      if assigned(Applet) then
        hWndOwner := Applet.Handle
      else
        hWndOwner := 0;

    hInstance := hInstance;

    lpstrFindWhat := @FFindText;
    wFindWhatLen := Sizeof(FFindText);

    lpstrReplaceWith := @FReplaceText;
    wReplaceWithLen := Sizeof(FReplaceText);

    //    lpfnHook := nil;//@FindReplaceHook;
    Flags := MakeFlags(@Options, FindReplaceDialogOption2Style);
  end;

  TMP.lCustData := LPARAM(@Self);

  case DialogType of
    dtFind: FHandle := CommDlg.FindText(TMP);
    dtReplace: FHandle := CommDlg.ReplaceText(TMP);
  end;

  if FHandle > 0 then
  begin
    MessageLoop;
    Result := True;
  end;
  Idx := DialogsList.IndexOf(@Self);
  DialogsList.Delete(Idx);
end;

procedure TMHFindReplaceDialog.MessageLoop;
var
  Msg: TMsg;
begin
  try
    while GetMessage(Msg, 0, 0, 0) and (FHandle > 0) do
    begin
      if IsDialogMessage(FHandle, Msg) = False then
      begin
        TranslateMessage(Msg);
        DispatchMessage(Msg);
      end;
    end;
  except
    ShowMessage('fhfgh');
  end;
end;

function TMHFindReplaceDialog.GetFindText: string;
begin
  Result := FFindText;
end;

function TMHFindReplaceDialog.GetReplaceText: string;
begin
  Result := FReplaceText;
end;

procedure TMHFindReplaceDialog.SetFindText(const Value: string);
begin
  StrLCopy(FFindText, PChar(Value), SizeOf(FFindText) - 1);
end;

procedure TMHFindReplaceDialog.SetReplaceText(const Value: string);
begin
  StrLCopy(FReplaceText, PChar(Value), SizeOf(FReplaceText) - 1);
end;

begin
  FindMsg := RegisterWindowMessage(FINDMSGSTRING);
  HelpMsg := RegisterWindowMessage(HELPMSGSTRING);
end.

