unit MCKMHFindReplaceDialog;
//  MHFindReplaceDialog  (MHFindReplaceDialog Component)
//   (Author):   (Zharov Dmitry) aka  (Gandalf)
//    (Create date): 1-(dec)-2001
//    (Last correction Date): 10-(may)-2004
//   (Version): 0.92
//  EMail: Gandalf@kol.mastak.ru
//   (Thanks):
//    (New in):
//  V0.92
//  [+]   ,    [KOLnMCK]
//  [N]    FindReplaceWndProc,  WM_CLOSE,  
//       ?
//
//  V0.81
//  [+]  D7 (D7 Support) [KOLnMCK]
//
//  V0.8
//  [N]   (Test version) [KOLnMCK]
//
//    (To-Do list):
//  1.  (Asm)
//  2.  (Optimize)
//  3.  (Clear Stuff)
//  4.  OnHelp (Events OnHelp)
//  5.  API (All API's)
//  6.   WM_CLOSE (Good WM_CLOSE)
//  7. / (Modal/No-Modal)

interface

uses
  KOL, KOLMHFindReplaceDialog, mirror, mckObjs, Classes, Graphics;

type

  TKOLMHFindReplaceDialog = class(TKOLObj)
  private
    FDialogType:TFindReplaceDialogType;
    FReplaceText:String;
    FFindText:String;
    FOptions:TFindReplaceDialogOptions;
    FOnReplace: TOnEvent;
    FOnFind: TOnEvent;
    procedure SetDialogType(const Value:TFindReplaceDialogType);
    procedure SetReplaceText(const Value:String);
    procedure SetFindText(const Value:String);
    procedure SetOptions(const Value:TFindReplaceDialogOptions);
    procedure SetOnFind(const Value: TOnEvent);
    procedure SetOnReplace(const Value: TOnEvent);
  protected
    function  AdditionalUnits: string; override;
    procedure AssignEvents(SL: TStringList; const AName: string); override;
    procedure SetupConstruct(SL: TStringList; const AName, AParent, Prefix: string);
    function SetupParams(const AName, AParent: string): string;
    procedure SetupFirst(SL: TStringList; const AName,AParent, Prefix: String); override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    property DialogType:TFindReplaceDialogType read FDialogType write SetDialogType;
    property ReplaceText:String read FReplaceText write SetReplaceText;
    property FindText:String read FFindText write SetFindText;
    property Options:TFindReplaceDialogOptions read FOptions write SetOptions;
    property OnFind : TOnEvent read FOnFind write SetOnFind;
    property OnReplace : TOnEvent read FOnReplace write SetOnReplace;
  end;

  procedure Register;

implementation

constructor TKOLMHFindReplaceDialog.Create(AOwner: TComponent);
begin
  inherited;
//  FCaption:='  ''''';
//  FCopyRight:='CopyRight 1984-2001';
//  FText:='  ''''';
//  FIcon := TIcon.Create;
end;

destructor TKOLMHFindReplaceDialog.Destroy;
begin
//  FIcon.Free;
  inherited;
end;

function TKOLMHFindReplaceDialog.AdditionalUnits;
begin
   Result := ', KOLMHFindReplaceDialog';
end;

procedure TKOLMHFindReplaceDialog.SetupFirst(SL: TStringList; const AName,
  AParent, Prefix: String);
var
  S: String;
begin
  SL.Add(''); // Add space for more code readability

  SetupConstruct(SL, AName, AParent, Prefix);

  S := '';
  if doDown in Options then
    S := 'doDown';
  if doWholeWord in Options then
    S := S + ', doWholeWord';
  if doMatchCase in Options then
    S := S + ', doMatchCase';
  if doFindNext in Options then
    S := S + ', doFindNext';
  if doReplace in Options then
    S := S + ', doReplace';
  if doReplaceAll in Options then
    S := S + ', doReplaceAll';
  {if doDialogTerm in Options then
    S := S + ', doDialogTerm'; }
  if doShowHelp in Options then
    S := S + ', doShowHelp';
  if doNoUpDown in Options then
    S := S + ', doNoUpDown';
  if doNoMatchCase in Options then
    S := S + ', doNoMatchCase';
  if doNoWholeWord in Options then
    S := S + ', doNoWholeWord';
  if doHideUpDown in Options then
    S := S + ', doHideUpDown';
  if doHideMatchCase in Options then
    S := S + ', doHideMatchCase';
  if doHideWholeWord in Options then
    S := S + ', doHideWholeWord';

  if S <> '' then
    if S[ 1 ] = ',' then
      S := Trim(Copy( S, 2, MaxInt ));

  if S<>'' then
    SL.Add( Prefix + '  ' + AName + '.Options:=['+S+'];');
  if FindText<>'' then
    SL.Add( Prefix + '  ' + AName + '.FindText:='''+FindText+''';');
  if ReplaceText<>'' then
    SL.Add( Prefix + '  ' + AName + '.ReplaceText:='''+ReplaceText+''';');
  if DialogType<>dtFind then
    SL.Add( Prefix + '  ' + AName + '.DialogType:=dtReplace;');
end;

procedure TKOLMHFindReplaceDialog.SetDialogType(const Value:TFindReplaceDialogType);
begin
  FDialogType:=Value;
  Change;
end;

procedure TKOLMHFindReplaceDialog.SetReplaceText(const Value:String);
begin
  FReplaceText:=Value;
  Change;
end;

procedure TKOLMHFindReplaceDialog.SetFindText(const Value:String);
begin
  FFindText:=Value;
  Change;
end;

procedure TKOLMHFindReplaceDialog.SetOptions(const Value:TFindReplaceDialogOptions);
begin
  FOptions:=Value;
  Change;
end;

procedure Register;
begin
  RegisterComponents('KOL Dialogs', [TKOLMHFindReplaceDialog]);
end;

procedure TKOLMHFindReplaceDialog.SetupConstruct(SL: TStringList;
  const AName, AParent, Prefix: string);
begin
   SL.Add(Prefix + AName + ' := New' + TypeName + '( '
      + SetupParams(AName, AParent) +  ');');
end;

function TKOLMHFindReplaceDialog.SetupParams(const AName,
  AParent: string): string;
begin
  Result := AParent;
end;

procedure TKOLMHFindReplaceDialog.AssignEvents(SL: TStringList;
  const AName: string);
begin
  inherited;
  DoAssignEvents(SL, AName, ['OnFind','OnReplace'], [@OnFind,@OnReplace]);
end;

procedure TKOLMHFindReplaceDialog.SetOnFind(const Value: TOnEvent);
begin
  FOnFind := Value;
  Change;
end;

procedure TKOLMHFindReplaceDialog.SetOnReplace(const Value: TOnEvent);
begin
  FOnReplace := Value;
  Change;
end;

end.

